//***********************************************************************
//
//  CLine.cpp
//
//***********************************************************************

#include <afxwin.h>
#include "CLine.h"

IMPLEMENT_SERIAL (CLine, CObject, 1)

CLine::CLine (CPoint ptFrom, CPoint ptTo, UINT nWidth, COLORREF crColor)
{
    m_ptFrom = ptFrom;
    m_ptTo = ptTo;
    m_nWidth = nWidth;
    m_crColor = crColor;
}

void CLine::Serialize (CArchive& ar)
{
    CObject::Serialize (ar);

    if (ar.IsStoring ())
        ar << m_ptFrom << m_ptTo << m_nWidth << (DWORD) m_crColor;
    else
        ar >> m_ptFrom >> m_ptTo >> m_nWidth >> (DWORD) m_crColor;
}

void CLine::Draw (CDC* pDC)
{
    CPen pen (PS_SOLID, m_nWidth, m_crColor);

    CPen* pOldPen = pDC->SelectObject (&pen);
    pDC->MoveTo (m_ptFrom);
    pDC->LineTo (m_ptTo);

    pDC->SelectObject (pOldPen);
}

CString CLine::GetDescription ()
{
    CString strDescription;
    strDescription.Format ("Line (%d,%d)-(%d,%d)\r\n",
        m_ptFrom.x, m_ptFrom.y, m_ptTo.x, m_ptTo.y);
    return strDescription;
}
