//***********************************************************************
//
//  Paint6Doc.h
//
//***********************************************************************

class CPaintDoc : public CDocument
{
    DECLARE_DYNCREATE (CPaintDoc)

private:
    UINT m_nWidth;
    UINT m_nColor;
    CObArray m_lineArray;

    void InitWidthAndColor ();

public:
    static const COLORREF m_crColors[8];

    CPaintDoc ();
    virtual BOOL OnNewDocument ();
    virtual BOOL OnOpenDocument (LPCTSTR);
    virtual void DeleteContents ();
    virtual void Serialize (CArchive&);

    CLine* AddLine (CPoint, CPoint);
    CLine* GetLine (int);
    int GetLineCount ();

protected:
    afx_msg void OnWidth (UINT);
    afx_msg void OnColor (UINT);
    afx_msg void OnUpdateWidthUI (CCmdUI*);
    afx_msg void OnUpdateColorUI (CCmdUI*);

    DECLARE_MESSAGE_MAP ()
};
